Program LengyelFormaraHozas; {az A2. reszfeladat programja}
(*
  Feladat:
          Aritmetikai kifejezs kirtkelse.

  A. Rszletesebben:
  A1. Egy kif sztringben hagyomnyos infix kifejezs van.
      Ezt lexiklis egysgeire bontjuk (lexEgys): lexKif.
      A lexEgys-eket hagyomnyos Text-ben (lexKif) troljuk:
      egy sor - egy lexiklis egysg bontsban.
  A2. Az elbbi lexiklis egysgeket tartalmaz file-bl
      kiindulva ellltjuk a post-fix lengyelformjt: pfKif.
      Ez is egy Text (pfKif), elbbivel azonos konvencival, azaz
      egy sor - egy lexiklis egysg.
  A3. A pfKif file-bl tovbblpve kiszmoljuk a kifejezs
      rtkt.
      Ha voltak a kifejezsben vltozk, akkor e programnak kell
      gondoskodnia az rtkek beolvassrl is.

  B. Mg rszletesebben:
  B1. Megengedett lexiklis egysgek. Azaz, amiket tartalmazhat
      a bemen (kif) sztring:
      B1.1. Szmkonstansok
      B1.2. Szmvltozk (azonostja egy betbl ll szveg)
      B1.3. Elemi aritmetikai mveleti jelek ('+','-','*','/','^')
      B1.4. Nhny valsrtk aritmetikai fggvny ('Sin','Cos',
           'Sqrt','Tg','Pi'...)
  B2. A bemen kifejezssel szemben elvrt specilis felttelek:
      B2.1. Minden lexiklis egysg kztt pontosan egy szkz van.
      B2.2. A fggvnyek argumentumt ktelez bezrjelezni.
      Pl.:
         a * Sin ( b * x + Pi / 2 ) - 5.4321
      B2.3. Kis- s nagybetket nem klnbztetnk meg.
      B2.4. A kifejezs eltt s utn nincsen szkz.
  B3. A lexiklis egysgek megjelense a lexKif Text-ben: rtkpr
      formjban.
        lexEgys --> (mifle + rtke)
      A mifle s hozzrendelt kdja:
      * Szmkonstans: 0
      * Szmvtloz: 1
      * Mvelet (s a zrjelek): 2
      Egy nhny lexiklis egysgre plda:
        ( 0 , '5.4321' )
        ( 1 , 'a' )
        ( 2 , 'Sin' )
      A lexKif file-ra plda:
        ( 1 , 'a' )
        ( 2 , '*' )
        ( 2 , 'Sin' )
        ( 2 , '(' )
        ( 1 , 'b' )
        ( 2 , '*' )
        ( 1 , 'x' )
        ( 2 , '+' )
        ...
        ( 0 , '5.4321' )
  B4. A lexiklis egysgek megjelense a pfKif Text-ben: rtkpr
      formjban.
        lexEgys --> (mifle + rtke)
      A pfKif file-ra plda:
        ( 1 , 'a' )
        ( 1 , 'b' )
        ( 1 , 'x' )
        ( 2 , '*' )
        ( 2 , 'Pi' )
        ( 0 , '2' )
        ( 2 , '/' )
        ( 2 , '+' )
        ( 2 , 'Sin' )
        ( 2 , '*' )
        ...
  C. Az egyes rszfeladatokat (l. A1-A3.) nllan fut programok
     vgzik el. A kapcsolatot file-okon keresztl tartjk.
     (Elkpzelhet, hogy a fent nevestett file-okon tl [lexKif, pfKif]
     tovbbiak is clszerek [pl. a mveleti tblt tartalmaz file,
     ami soronknt felsorolja a leglis opertorokat esetleg precedencijukkal
     egytt; ekppen:
       + 5
       - 5
       * 6
       / 6
       ^ 7
       Pi 10
       Sin 10
       Cos 10
       Tg 10
       Sqrt 10
     )

*)
  Uses Newdelay,Crt,Crt22;

  {$i AltRutin.inc}
  {$i lengyel.inc -- a lengyelforma kiertekeles programjainak kozos dolgai}

  Var   lexKif:Text; {file input: Text-esitett,
                      soregysegre tordelt TLexEgys file}
        pfKif:Text;  {file output: Text-esitett,
                      soregysegre tordelt TLexEgys file}
  Const lexKifFn='lexKif.txt';
        pfKifFn='pfKif.txt';
  Const tollSzin=Black;
        papirSzin=White;
        link=128;

  Type  TElem=TMuvJel;
  {$i VeremObj.inc (TElem)}

  Procedure FileMegnyitasIrasra(fN:String; Var f:Text);
    Var  hiba:Integer;
  Begin
    UjLap('Lengyelforma -- file-megnyits',0);
    Repeat
      {$i-}
      Assign(f,fN); Reset(f);
      hiba:=IOResult;
      If hiba<>0 then
      Begin
        Rewrite(f);
        hiba:=IOResult;
        If hiba<>0 then
        Begin
          TextColor(Red+Blink);
          Writeln('A file nem nyithat meg:');
          Writeln('  Hibs file-nv.');
          TextColor(tollSzin);
          BillreVar
        End
      End
        Else
      Begin
        Rewrite(f);
        TextColor(Red+Blink);
        Writeln('  Ilyen file mr van. A file fellrdik.');
        TextColor(tollSzin);
        BillreVar
      End;
      {$i+}
    Until hiba=0;
  End;

  Procedure FileMegnyitasOlvasasra(fN:String; Var f:Text);
    Var  hiba:Integer;
  Begin
    UjLap('Lengyelforma -- file-megnyits',0);
    Repeat
      {$i-}
      Assign(f,fN); Reset(f);
      hiba:=IOResult;
      If hiba<>0 then
      Begin
        TextColor(Red+Blink);
        Writeln('A file nem nyithat meg:');
        Writeln('  Hibs file-nv.');
        TextColor(tollSzin);
        BillreVar
      End
      {$i+}
    Until hiba=0;
  End;

  Function Precedencia(oper:TMuvJel):Byte;
    Var i:Byte;
  Begin
    i:=1;
    While (oper<>Op[i].jel) do Inc(i);
    Precedencia:=Op[i].prec
  End;

  Procedure PfReHozas(Var lexKif,pfKif:Text);
    Var sle,le:OLexEgys;
        v:OVerem;
  Begin
    v.Letrehoz;
    sle.Letrehoz(Vege,'');
    le.Letrehoz(Vege,'');
    le.Readln(lexKif);
    While le.ertek<>'' do
    Begin
      If le.mifele=Muv then
      Begin
        If
          le.ertek='(' then
            Begin
              v.Berak(le.ertek);
            End else if
          le.ertek=')' then
            Begin
              While v.tomb[v.teto]<>'(' do
              Begin
                sle.mifele:=Muv; v.Kivesz(sle.ertek);
                sle.Writeln(pfKif);
              End;
              sle.mifele:=Muv; v.Kivesz(sle.ertek);
            End
           else
            Begin
              While Not v.UresE and
                    (Precedencia(v.tomb[v.teto])>=Precedencia(le.ertek)) do
              Begin
                sle.mifele:=Muv; v.Kivesz(sle.ertek);
                sle.Writeln(pfKif);
              End;
              v.Berak(le.ertek);
            End;
      End
        else
      Begin
        le.Writeln(pfKif);
      End;
      le.Readln(lexKif);
    End;
    {veremurites:}
    While Not v.UresE do
    Begin
      sle.mifele:=Muv; v.Kivesz(sle.ertek);
      sle.Writeln(pfKif);
    End;
    sle.Lerombol;
    le.Lerombol;
  End;

Begin
  UjLap('Lengyelforma',0);
  TextColor(tollSzin); TextBackground(papirSzin);
  FileMegnyitasOlvasasra(lexKifFn,lexKif);
  FileMegnyitasIrasra(pfKifFn,pfKif);
  PfReHozas(lexKif,pfKif);
  Close(lexKif);
  Close(pfKif);
End.